#include <iostream>
#include <bitset>
#include "testlib.h"

#define int long long
using namespace std;


vector<int> aha;
vector<vector<int>> aa;
vector<vector<pair<int, int>>> edges;
vector<int> ck;

signed main(int argc, char* argv[])
{
    registerGen(argc, argv, 1);
    int fix_n = atoi(argv[1]);
    int low_k = atoi(argv[2]);
    int high_k = atoi(argv[3]);
    int sum_n = atoi(argv[4]);
    int cur_n_sum = 0;
    vector<int> cur_msk;
    for (int msk = 0; msk < (1ll << fix_n * (fix_n - 1) / 2); ++msk) {
        cur_msk.push_back(msk);
    }
    for (int ms = 0; ms < cur_msk.size(); ++ms) {
        if (cur_n_sum + fix_n > sum_n) break;
        int msk = cur_msk[ms];
        cur_n_sum += fix_n;
        int rK = rnd.next(low_k, high_k);
        ck.push_back(rK);
        aha.push_back(fix_n);
        vector<pair<int, int>> edg;
        if (msk & 1) edg.push_back({ 1, 2 });
        if (msk & 2) edg.push_back({ 1, 3 });
        if (msk & 4) edg.push_back({ 1, 4 });
        if (msk & 8) edg.push_back({ 2, 3 });
        if (msk & 16) edg.push_back({ 2, 4 });
        if (msk & 32) edg.push_back({ 3, 4 });
        edges.push_back(edg);
        vector<int> tmp;
        for (int i = 0; i < fix_n; ++i) {
            tmp.push_back(rnd.next(0ll, (1ll << rK) - 1));
        }
        aa.push_back(tmp);
    }
    cout << aha.size() << "\n";
    for (int i = 0; i < aha.size(); ++i) {
        cout << aha[i] << " " << edges[i].size() << " " << ck[i] << "\n";
        for (int j = 0; j < aa[i].size(); ++j) {
            cout << aa[i][j];
            if (j + 1 != aa[i].size()) cout << " ";
        }
        cout << "\n";
        for (auto x : edges[i]) {
            cout << x.first << " " << x.second << "\n";
        }
    }
}
