#include <iostream>
#include <iomanip>
#include <fstream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <stack>
#include <deque>
#include <string>
#include <ctime>
#include <bitset>
#include <queue>
#include <cassert>
#include<unordered_set>
#include<unordered_map>
#include<string.h>
#include <random>
#include <chrono>
#include <math.h>
//#include <bit>
#include <climits>
using namespace std;
#pragma GCC optimize("O3")
#pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt")
#define pb push_back
#define all(a) a.begin(), a.end()
#define repeat(a) for (int i31 = 0; i31 < a; ++i31)
#define newl '\n'
//#define int long long
#define ll long long
//#define ld double
#define pi pair<int, int>
#define pll pair<ll, ll>
#define mint map<int, int>*;
#define vi vector<int>
#define ull unsigned long long
#define pb push_back
#define newl '\n'
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define repeat(a) for (int i31 = 0; i31 < a; ++i31)
#define ld long double
template<typename T>
istream& operator>>(istream& is, vector<T>& v) {
	for (T& o : v) {
		is >> o;
	}
	return is;
}
class Query {
public:
	int l = 0;
	int r = 0;
	int idx = 0;
	Query(int L, int R, int Num) {
		l = L;
		r = R;
		idx = Num;
	}
};
int NOD(int a, int b) {
	if (a < 0 || b < 0) return NOD(abs(a), abs(b));
	return b ? NOD(b, a % b) : a;
}
//const ld EPS = 1e-9;
const ll INF = 1e18 + 3;
const ll MOD1 = 1000000007;
const ll POWER = 5;
const ll HASHMOD1 = 939999971;
const ll HASHMOD2 = 23;
const ll MOD2 = 998244353;
//const ld PHI = atan(1) * 4;
const ll MOD3 = 1e9 + 7;
const int root = 31;
const int root_1 = 128805723;
const int root_pw = 1 << 23;
vector<int> dX = { 1, 0, -1, 0, };
vector<int> dY = { 0, 1, 0, -1 };
mt19937 MT(17726);
ifstream fin("aha.txt");
const int LOG = 19;
const int PR = 67;
const int mM = 305;
const int block_size = 300;
const int SSIZE = 1001;
const int maxN = 55;
const int ST = 26;
const int MOD_CUR = 998244353;
const int MAXN = 5e5 + 5;

const int KMAX = 24;
bool isKthBitSet(int num, int k) {
	return num & (1ll << k);
}
struct bor_node {
	bor_node* r = nullptr;
	bor_node* l = nullptr;
	bor_node() {
		r = nullptr;
		l = nullptr;
	}
};

void clear(bor_node* v) {
	if (v->l) {
		clear(v->l);
	}
	if (v->r) {
		clear(v->r);
	}
	delete v;
}

void insert(int num, int k, bor_node* rt) {
	if (k == -1) return;
	if (isKthBitSet(num, k)) {
		if (rt->r == nullptr) rt->r = new bor_node();
		insert(num, k - 1, rt->r);
	}
	else {
		if (rt->l == nullptr) rt->l = new bor_node();
		insert(num, k - 1, rt->l);
	}
}

int gt(int num, int k, bor_node* rt) {
	if (rt == nullptr) return 0;
	if (k == -1) return 0;
	if (isKthBitSet(num, k)) {
		if (rt->l != nullptr) {
			return gt(num, k - 1, rt->l) + (1ll << k);
		}
		else {
			return gt(num, k - 1, rt->r);
		}
	}
	else {
		if (rt->r != nullptr) {
			return gt(num, k - 1, rt->r) + (1ll << k);
		}
		return gt(num, k - 1, rt->l);
	}
}

void solve() {
	int N = 0, M = 0, K = 0; cin >> N >> M >> K;
	pi ans = { -1, -1 };
	vector<vector<int>> fr; fr.assign(N, vi(N, 0));
	vector<int> a; a.assign(N, 0); for (auto& x : a) cin >> x;
	int fir = -1; int sec = -1;
	for (int i = 0; i < M; ++i) {
		int u = 0, v = 0; cin >> u >> v; u--; v--;
		fr[u][v] = fr[v][u] = 1;
	}
	if (N <= KMAX) {
		vector<bool> msk;
		msk.assign((1ll << N), false);
		msk[0] = true;
		vector<int> sbit; sbit.reserve(N);
		for (int j = 1; j < (1ll << N); ++j) {
			sbit.clear();
			for (int k = 0; k < N; ++k) {
				if (isKthBitSet(j, k)) sbit.push_back(k);
			}
			int fir = sbit[0];
			if (!msk[j ^ (1ll << fir)]) continue;
			bool all = true;
			for (int pr = 1; pr < sbit.size(); ++pr) {
				if (!fr[fir][sbit[pr]]) {
					all = false;
					break;
				}
			}
			msk[j] = all;
		}
		for (int mask = 1; mask < (1ll << N); ++mask) {
			if (!msk[mask]) continue;
			int xr = 0;
			int t = 0;
			for (int ps = 0; ps < N; ++ps) {
				if (isKthBitSet(mask, ps)) {
					t++;
					xr = xr ^ a[ps];
				}
			}
			if (t > fir) {
				fir = t; sec = xr;
			}
			else {
				if (fir == t) sec = max(sec, xr);
			}
		}
		cout << fir << " " << sec << "\n";
		return;
	}
	vector<bool> msk;
	msk.assign((1ll << KMAX), false);
	msk[0] = true;
	vector<int> sbit; sbit.reserve(KMAX);
	for (int pr = 1; pr < (1ll << KMAX); ++pr) {
		sbit.clear();
		bool brk = false;
		int xr = 0;
		for (int j = 0; j < KMAX; ++j) {
			if (isKthBitSet(pr, j)) {
				xr = xr ^ a[j];
				if (!msk[pr ^ (1ll << j)]) brk = true;
				sbit.push_back(j);
			}
		}
		if (brk) continue;
		for (int s = 1; s < sbit.size(); ++s) {
			if (!fr[sbit[s]][sbit[0]]) {
				brk = true;
				break;
			}
		}
		if (brk) continue;
		msk[pr] = true;
		ans = max(ans, { sbit.size(), xr });
	}
	vector<int> other_msk;
	int other_size = N - KMAX;
	other_msk.assign((1ll << KMAX), 0);
	other_msk[0] = (1ll << other_size) - 1;
	for (int ms = 1; ms < (1ll << KMAX); ++ms) {
		if (!msk[ms]) continue;
		int fir = -1;
		for (int k = 0; k < KMAX; ++k) {
			if (isKthBitSet(ms, k)) {
				fir = k;
				break;
			}
		}
		int wrt = other_msk[ms ^ (1ll << fir)];
		for (int j = 0; j < other_size; ++j) {
			if (!isKthBitSet(wrt, j)) continue;
			if (!fr[j + KMAX][fir]) wrt = wrt ^ (1ll << j);
		}
		other_msk[ms] = wrt;
	}
	vector<vector<pair<int, int>>> reqs;
	reqs.assign((1ll << other_size), vector<pi>());
	for (int j = 0; j < reqs.size(); ++j) reqs[j].reserve(10);
	for (int ms = 1; ms < (1ll << KMAX); ++ms) {
		if (!msk[ms]) continue;
		int sz = 0;
		int xr = 0;
		for (int j = 0; j < KMAX; ++j) {
			if (isKthBitSet(ms, j)) {
				sz++;
				xr = xr ^ a[j];
			}
		}
		int mask2 = other_msk[ms];
		if (ans.first > sz + other_size) continue;
		if (!reqs[mask2].empty()) {
			if (reqs[mask2].front().first > sz) continue;
			if (reqs[mask2].front().first < sz) {
				reqs[mask2].clear();
			}
			reqs[mask2].push_back({ sz, xr });
		}
		else {
			reqs[mask2].push_back({ sz, xr });
		}
	}
	vector<bor_node*> vv;
	vv.assign((1ll << other_size), new bor_node());
	vector<int> mx_clique;
	vector<bool> is_clique; is_clique.assign((1ll << other_size), false);
	is_clique[0] = true;
	vector<vector<int>> xrs;
	xrs.assign((1ll << other_size), vi());
	for(int j = 0; j < xrs.size(); ++j) {
	    xrs[j].reserve(10);
	}
	xrs[0].push_back(0);
	mx_clique.assign(1ll << other_size, 0);
	for (int ps = 1; ps < (1ll << other_size); ++ps) {
		sbit.clear();
		for (int p = 0; p < other_size; ++p) {
			if (isKthBitSet(ps, p)) sbit.push_back(p);
		}
		bool clq = true;
		if (!is_clique[ps ^ (1ll << sbit[0])]) {
			clq = false;
		}
		else {
			for (int j1 = 1; j1 < sbit.size(); ++j1) {
				if (!fr[sbit[0] + KMAX][sbit[j1] + KMAX]) {
					clq = false;
					break;
				}
			}
		}
		is_clique[ps] = clq;
		vv[ps] = new bor_node();
		if (is_clique[ps]) {
			mx_clique[ps] = sbit.size();
			int xr = 0;
			for (int j = 0; j < sbit.size(); ++j) {
				xr = xr ^ a[sbit[j] + KMAX];
			}
			xrs[ps].push_back(xr);
			insert(xr, K, vv[ps]);
			for (auto& x : reqs[ps]) {
				ans = max(ans, { x.first + mx_clique[ps], gt(x.second, K, vv[ps]) });
			}
			clear(vv[ps]);
			continue;
		}
		int mx = -1;
		for (int j = 0; j < sbit.size(); ++j) {
			mx = max(mx, mx_clique[ps ^ (1ll << sbit[j])]);
		}
		mx_clique[ps] = mx;
		for (int j = 0; j < sbit.size(); ++j) {
			if (mx_clique[ps ^ (1ll << sbit[j])] != mx) continue;
			for (auto x : xrs[ps ^ (1ll << sbit[j])]) {
				xrs[ps].push_back(x);
				insert(x, K, vv[ps]);
			}
		}
		for (auto& x : reqs[ps]) {
			ans = max(ans, { x.first + mx_clique[ps], gt(x.second, K, vv[ps]) });
		}
		if (MT() % 4 != 0) clear(vv[ps]);
		sort(xrs[ps].begin(), xrs[ps].end());
		vector<int> nval;
		for (int i = 0; i < xrs[ps].size(); ++i) {
			if (i == 0 || xrs[ps][i] != xrs[ps][i - 1]) nval.push_back(xrs[ps][i]);
		}
		swap(nval, xrs[ps]);
	}
	for (int ps = 1; ps < (1ll << other_size); ++ps) {
		if (is_clique[ps]) {
			ans = max(ans, { mx_clique[ps], xrs[ps][0] });
		}
	}
	cout << ans.first << " " << ans.second << "\n";
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cout << setprecision(20);
	int T = 1;
	cin >> T;
	while (T--)
		solve();
	return 0;
}
