#include "testlib.h"

#define fori(n) for (int i = 0; i < (n); ++i)
#define ll long long
#define MAX_SUM ((ll)1e18)

using namespace std;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int n = has_opt("n") ? opt<int>("n") : (int)2e5;
    int q = has_opt("q") ? opt<int>("q") : (int)2e5;
    int max_h = has_opt("h") ? opt<int>("h") : (int)1e9;
    int max_p = has_opt("p") ? opt<int>("p") : (int)1e9;
    int f_p = has_opt("p1") ? opt<int>("p1") : -1;
    int s_p = has_opt("p2") ? opt<int>("p2") : -1;
    int equals = has_opt("equals") ? opt<int>("equals") : 0;

    while (f_p == -1) f_p = rnd.next(1, max_p);
    while (s_p == -1 || s_p == f_p) s_p = rnd.next(1, max_p);

    ll mm = MAX_SUM / max(f_p, s_p) / n;

    ll h = rnd.next(1ll, min<ll>(max_h, mm));

    println(n, q);

    ll sum = 0;
    fori(n) {
        ll stay = MAX_SUM - sum;
        ll can_use = stay - (n - i - 1) * max(f_p, s_p) * h;
        ll p = min<ll>({(ll)1e9, equals ? (rnd.next(0, 1) ? f_p : s_p) : rnd.next(1ll, max<ll>(f_p, s_p)), max_p});
        println(p, h);
    }
    fori(q) {
        println(rnd.next(1, max_p));
    }
}
