/*
    @author: doreshnikov
    Daniil Oreshnikov, ITMO University
*/

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int uint;
typedef pair<int, int> pii;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

#define all(c) c.begin(), c.end()

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    in(int, n, q, pts, gamma)
    vector<int> a(n);
    cin >> a;

    for (int t = 0; t < q; t++) {
        in(int, l, r)
        l--;
        int len = r - l;

        int answer = len + 1, mx = 1;
        for (int i = 1; i <= len; i++) {
            int result = i + (len + i - 1) / i;
            if (answer > result) {
                answer = result;
                mx = i;
            }
        }

        vector<int> actions;
        int rem = len % mx;
        for (int i = 0; i < mx; i++) {
            actions.push_back(1);
            if (actions.size() == rem) {
                actions.push_back(0);
                len -= rem;
            }
        }
        while (len > 0) {
            actions.push_back(0);
            len -= mx;
        }

        cout << actions.size() << '\n';
        for (int item : actions) {
            cout << item << ' ';
        }
        cout << '\n';
    }

}