/*
    @author: doreshnikov
    Daniil Oreshnikov, ITMO University
*/

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int uint;
typedef pair<int, int> pii;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

#define all(c) c.begin(), c.end()

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    in(int, n, q, pts, gamma)
    vector<int> a(n);
    cin >> a;

    for (int i = 0; i < q; i++) {
        in(int, l, r)
        l--;
        cout << r - l + 1 << '\n';
        for (int idx = l; idx < r; idx++) {
            cout << a[idx] << ' ';
        }
        cout << "0\n";
    }

}