#include <iostream>
#include <bitset>
#include "testlib.h"
 
#define int long long
using namespace std;
 
 
vector<int> aha;
vector<vector<int>> aa;
vector<vector<pair<int, int>>> edg;
vector<int> ck;
 
void gener(int n, int k) {
    vector<int> tmp;
    for (int s = 0; s < n; ++s) {
        tmp.push_back(rnd.next(0ll, (1ll << k) - 1));
    }
    for(int s = 0; s < n / 2; ++s) tmp[s] = 1;
    for(int s = n / 2; s < n; ++s) tmp[s] = 2;
    aa.push_back(tmp);
    vector<pair<int, int>> edges;
    vector<vector<int>> fr;
    fr.assign(n, vector<int>(n, 0));
    for (int j = 0; j < (n / 3); ++j) {
        int l1 = j * 3;
        int l2 = j * 3 + 1;
        int l3 = j * 3 + 2;
        fr[l1][l2] = 1;
        fr[l1][l3] = 1;
        fr[l2][l3] = 1;
    }
    if (n % 3 == 2) {
        int lft1 = n - 1;
        int lft2 = n - 2;
        fr[lft2][lft1] = 1;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            fr[i][j] = fr[i][j] ^ 1;
            if (fr[i][j]) edges.push_back({ i + 1, j + 1 });
        }
    }
    shuffle(edges.begin(), edges.end());
    edg.push_back(edges);
}
 
signed main(int argc, char* argv[])
{
    registerGen(argc, argv, 1);
    int sum_n = atoi(argv[1]);
    int low_n = atoi(argv[2]);
    int high_n = atoi(argv[3]);
    int cur_n_sum = 0;
    while (cur_n_sum + low_n <= sum_n) {
        int mn = min(high_n, sum_n - cur_n_sum);
        int act_n = rnd.next(low_n, mn);
        if(act_n % 2 == 1) act_n--;
        cur_n_sum += act_n;
        int act_k = 2;
        ck.push_back(act_k);
        aha.push_back(act_n);
        gener(act_n, act_k);
    }
    cout << aha.size() << "\n";
    for (int i = 0; i < aha.size(); ++i) {
        cout << aha[i] << " " << edg[i].size() << " " << ck[i] << "\n";
        for (int j = 0; j < aa[i].size(); ++j) {
            cout << aa[i][j];
            if (j + 1 != aa[i].size()) cout << " ";
        }
        cout << "\n";
        for (auto x : edg[i]) {
            cout << x.first << " " << x.second << "\n";
        }
    }
}
