#include <iostream>
#include <bitset>
#include "testlib.h"
 
#define int long long
using namespace std;
 
 
vector<int> aha;
vector<vector<int>> aa;
vector<vector<pair<int, int>>> edges;
vector<int> ck;
void gen(int n, int k, int prob1, int prob2) {
    ck.push_back(k);
    aha.push_back(n);
    vector<int> tmp;
    for (int s = 0; s < n; ++s) {
        tmp.push_back(rnd.next(0ll, (1ll << k) - 1));
    }
    for(int s = 0; s < n/  2; ++s) {
        tmp[s] = 1; tmp[s + n / 2] = 2;
    }    
    aa.push_back(tmp);
    vector<pair<int, int>> cedges;
    for (int j = 0; j < n; ++j) {
        for (int s = j + 1; s < n; ++s) {
            int gn = rnd.next(1ll,prob2);
            if (gn <= prob1) cedges.push_back({ j + 1, s + 1 });
        }
    }
    edges.push_back(cedges);
}
 
signed main(int argc, char* argv[])
{
    registerGen(argc, argv, 1);
    int sum_n = atoi(argv[1]);
    int min_n = atoi(argv[2]);
    int max_n = atoi(argv[3]);
    int fr1 = atoi(argv[4]);
    int fr2 = atoi(argv[5]);
    int cur_n_sum = 0;
    while (cur_n_sum + min_n <= sum_n) {
        int high_gr = min(sum_n - cur_n_sum, max_n);
        int gener_n = rnd.next(min_n, high_gr);
        if(gener_n % 2 == 1) gener_n--;
        int gen_k = 2;
        gen(gener_n, gen_k, fr1, fr2);
        cur_n_sum += gener_n;
    }
    cout << aha.size() << '\n';
    for (int j = 0; j < aha.size(); ++j) {
        cout << aha[j] << " " << edges[j].size() << " " << ck[j] << "\n";
        for (int i = 0; i < aa[j].size(); ++i) {
            cout << aa[j][i];
            if (i + 1 != aa[j].size()) cout << " ";
        }
        cout << "\n";
        for (auto x : edges[j]) {
            cout << x.first << " " << x.second << "\n";
        }
    }
}
