//#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

#define X first
#define Y second


const ll mod = 1000000007;
//const ll mod = 998244353;



const int mx = 2048;
int dp[mx][mx], prv[mx][mx], up[mx][mx];
int n;

void ask(int L, int n2)
{
    for (int i=L;i<=n2;i++)
    {
        for (int j=i;j<=n2;j++)
        {
            dp[i][j] = mod;
            prv[i][j] = -mod;
        }
    }
    dp[L][L] = 0;
    for (int i=L;i<=n2;i++)
    {
        for (int j=i;j<n2;j++)
        {
            if (dp[i][j+1]>dp[i][j]+1)
            {
                dp[i][j+1] = dp[i][j]+1;
                prv[i][j+1] = -1;
            }
        }
        for (int j=n2;j>i;j--)
        {
            if (dp[i][j-1]>dp[i][j]+1)
            {
                dp[i][j-1] = dp[i][j]+1;
                prv[i][j-1] = -2;
            }
        }
        for (int j=i;j<=n2;j++)
        {
            int k = up[i][j];
            k = min(k,j-i);
            k = min(k,n2-j);
            int S = dp[i][j]+(j-i-k)+1;
            int p = j+k;
            if (dp[j][p]<=S) continue;
            dp[j][p] = S;
            prv[j][p] = i;
        }
    }
}

void solve()
{
    int q;
    cin >> n >> q;
    int _, __;
    cin >> _ >> __;
    vector<int> a(n,1);
    for (int i=0;i<n;i++) cin >> a[i];
    int F = 0;
    for (int i=0;i+1<n;i++)
    {
        if (a[i]!=a[i+1]) F = 1;
    }
    if (F==0)
    {
        while (q--)
        {
            int L, R;
            cin >> L >> R;
            R = R-L+1;
            int W = 0;
            while (W*W<R) W++;
            vector<int> D(W+1);
            D[W] = R/W;
            R %= W;
            if (R>0) D[R]++;
            vector<int> A;
            for (int i=1;i<=W;i++)
            {
                A.push_back(a[0]);
                while (D[i]>0) A.push_back(0), D[i]--;
            }
            cout << A.size() << "\n";
            for (int x: A) cout << x << " ";
            cout << "\n";
        }
        return;
    }
    for (int i=0;i<=n;i++)
    {
        for (int j=0;j<=n;j++) up[i][j] = 0;
    }
    for (int i=n-1;i>=0;i--)
    {
        for (int j=0;j<n;j++)
        {
            if (a[i]==a[j]) up[i][j] = up[i+1][j+1]+1;
            else up[i][j] = 0;
        }
    }
    vector<pair<pair<int,int>,int>> Q(q);
    vector<int> was;
    for (int i=0;i<q;i++)
    {
        int L, R;
        cin >> L >> R;
        L--;
        Q[i] = {{L,R},i};
    }
    sort(Q.begin(),Q.end());
    vector<vector<int>> A(q);
    for (int i=0;i<Q.size();)
    {
        int L = Q[i].X.X;
        {
            int w = i;
            int n2 = Q[i].X.Y;
            while (w<Q.size() and Q[w].X.X==L)
            {
                n2 = Q[w].X.Y;
                w++;
            }
            ask(L,n2);
        }
        int j = i;
        while (j<Q.size() and Q[j].X.X==L)
        {
            int pos = Q[j].Y;
            int J = Q[j].X.Y;
            int I = Q[j].X.X;
            for (int w=L;w<=J;w++)
            {
                if (dp[w][J]<dp[I][J]) I = w;
            }
            vector<int> cur;
            cur.push_back(0);
            while (I!=L or J!=L)
            {
                int p = prv[I][J];
                if (p==-1)
                {
                    J--;
                    cur.push_back(a[J]);
                    continue;
                }
                if (p==-2)
                {
                    J++;
                    cur.push_back(-1);
                    continue;
                }
                int k = up[p][I];
                k = min(k,I-p);
                int del = I-p-k;
                for (int w=0;w<del;w++) cur.push_back(-1);
                cur.push_back(0);
                J = I;
                I = p;
            }
            reverse(cur.begin(),cur.end());
            A[pos] = cur;
            j++;
        }
        i = j;
    }
    for (int i=0;i<q;i++)
    {
        cout << A[i].size() << "\n";
        for (int x: A[i]) cout << x << " ";
        cout << "\n";
    }
}


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    ll T;
    T = 1;
    //cin >> T;
    while (T--) solve();
}